
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# provide meta-data
set(librepomgr_varname "LIBREPOMGR")
set(librepomgr-git_varname "LIBREPOMGR")
set(LIBREPOMGR_DISPLAY_NAME "Unofficial Arch Linux repository management library (git)")
set(LIBREPOMGR_AUTHOR "Martchus")
set(LIBREPOMGR_VERSION "0.0.1-433.ac30fd2")
set(LIBREPOMGR_VERSION_MAJOR "0")
set(LIBREPOMGR_VERSION_MINOR "0")
set(LIBREPOMGR_VERSION_PATCH "1")
set(LIBREPOMGR_GIT_REV_COUNT "433")
set(LIBREPOMGR_GIT_LAST_COMMIT_ID "ac30fd2")
set(LIBREPOMGR_URL "https://github.com/Martchus/arch-repo-manager")
set(LIBREPOMGR_DESCRIPTION "Library for managing custom Arch Linux repositories")
set(LIBREPOMGR_LICENSE "GPL-2.0+")

# define general config
set(LIBREPOMGR_IS_HEADER_ONLY NO)
set(LIBREPOMGR_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include/librepomgr-git")
set(LIBREPOMGR_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin")
set(LIBREPOMGR_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib")
set(LIBREPOMGR_DATA_DIRS "${PACKAGE_PREFIX_DIR}/share/librepomgr-git")
set(LIBREPOMGR_MODULE_DIRS "${PACKAGE_PREFIX_DIR}/share/librepomgr-git/cmake/modules")
set(LIBREPOMGR_CONFIG_DIRS "${PACKAGE_PREFIX_DIR}/share/librepomgr-git/cmake")
set(LIBREPOMGR_PRIVATE_QT_MODULES "")
set(LIBREPOMGR_PRIVATE_KF_MODULES "")
set(LIBREPOMGR_PUBLIC_QT_MODULES "")
set(LIBREPOMGR_PUBLIC_KF_MODULES "")
set(LIBREPOMGR_REQUIRED_PACKAGES "c++utilities-git;reflective_rapidjson-git;libpkg-git;OpenSSL")
set(LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULES "")
set(LIBREPOMGR_HAS_QT_TRANSLATION_FILES )
set(LIBREPOMGR_QT_RESOURCES )

# define mapping from CMake targets to pkg-config module names
set(PKG_CONFIG_librepomgr-git "librepomgr-git")

# define additional find_package arguments for required CMake-packages

# define library config, add imported target
set(LIBREPOMGR_PACKAGE "librepomgr-git")
set(LIBREPOMGR_LIB "librepomgr-git")
set(LIBREPOMGR_LIB_IS_SHARED "ON")
set(LIBREPOMGR_STATIC_LINKAGE "OFF")
if(NOT TARGET "${LIBREPOMGR_LIB}")
    # make dependencies of the library available
    # caveat: This currently does *not* cover Qt and KF modules which are so far only handled
    #         separately when using the function use_LIBREPOMGR.

    # prefer static libraries if librepomgr was configured this way during its build
    if (LIBREPOMGR_STATIC_LINKAGE)
        set(LIBREPOMGR_DEFAULT_CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES})
        if (WIN32)
            set(CMAKE_FIND_LIBRARY_SUFFIXES .a .lib)
        else ()
            set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
        endif ()
        set(LIBREPOMGR_DEFAULT_PKG_CONFIG_USE_STATIC_LIBS ${PKG_CONFIG_USE_STATIC_LIBS})
        set(PKG_CONFIG_USE_STATIC_LIBS ON)
    endif ()

    # find all required packages
    foreach (_REQUIRED_PACKAGE ${LIBREPOMGR_REQUIRED_PACKAGES})
        string(REGEX MATCH _REQUIRED_PACKAGE_MATCH "(.*)-([^-]*)" "${_REQUIRED_PACKAGE}")
        if (_REQUIRED_PACKAGE_MATCH)
            set(_REQUIRED_PACKAGE "${CMAKE_MATCH_1}")
            set(_REQUIRED_VERSION "${CMAKE_MATCH_2}")
        else ()
            unset(_REQUIRED_VERSION)
        endif ()
        string(REPLACE "::" "_" _REQUIRED_PACKAGE_VARNAME "${_REQUIRED_PACKAGE}")
        if (LIBREPOMGR_FIND_PACKAGE_ARGS_${_REQUIRED_PACKAGE_VARNAME})
            set(_FIND_PACKAGE_ARGS ${LIBREPOMGR_FIND_PACKAGE_ARGS_${_REQUIRED_PACKAGE_VARNAME}})
        else ()
            set(_FIND_PACKAGE_ARGS REQUIRED)
        endif ()
        if (_REQUIRED_VERSION)
            find_package("${_REQUIRED_PACKAGE}" "${_REQUIRED_VERSION}" ${_FIND_PACKAGE_ARGS})
        else ()
            find_package("${_REQUIRED_PACKAGE}" ${_FIND_PACKAGE_ARGS})
        endif()
    endforeach()

    # find all required pkg-config modules
    if (LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULES)
        include(3rdParty)
        foreach (LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULE ${LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULES})
            string(REPLACE "::" "_" LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULE_VARNAME "${LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULE}")
            use_pkg_config_module(
                TARGET_NAME "${LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULE}"
                PKG_CONFIG_MODULES "${PKG_CONFIG_${LIBREPOMGR_REQUIRED_PKG_CONFIG_MODULE_VARNAME}}"
                LIBRARIES_VARIABLE DEV_NULL
                PKG_CONFIG_MODULES_VARIABLE DEV_NULL
            )
        endforeach ()
    endif ()

    # restore preference of static libraries
    if (LIBREPOMGR_STATIC_LINKAGE)
        set(CMAKE_FIND_LIBRARY_SUFFIXES ${LIBREPOMGR_DEFAULT_CMAKE_FIND_LIBRARY_SUFFIXES})
        unset(LIBREPOMGR_DEFAULT_CMAKE_FIND_LIBRARY_SUFFIXES)
        set(PKG_CONFIG_USE_STATIC_LIBS ${LIBREPOMGR_DEFAULT_PKG_CONFIG_USE_STATIC_LIBS})
        unset(LIBREPOMGR_DEFAULT_PKG_CONFIG_USE_STATIC_LIBS)
    endif ()

    # add target for the library itself
    include("${CMAKE_CURRENT_LIST_DIR}/librepomgr-gitTargets.cmake")
endif()

# define function to ease use of library in projects following conventions of c++utilities' build script
function(use_LIBREPOMGR)
    # make CMake modules of the project available
    list(APPEND CMAKE_MODULE_PATH "${LIBREPOMGR_MODULE_DIRS}")
    set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" PARENT_SCOPE)

    # parse arguments
    include(3rdParty)
    parse_arguments_for_use_functions(${ARGN})

    # link against library (also "link" against header-only libs to get compile defs and interface link libs)
    link_directories(${LIBREPOMGR_LIB_DIR})
    if (ARGS_ONLY_HEADERS)
        set(TARGET_NAME "${LIBREPOMGR_LIB}-headers")
    else ()
        set(TARGET_NAME "${LIBREPOMGR_LIB}")
    endif ()
    set("${ARGS_LIBRARIES_VARIABLE}" "${${ARGS_LIBRARIES_VARIABLE}};${TARGET_NAME}" PARENT_SCOPE)
    set("${ARGS_PACKAGES_VARIABLE}" "${${ARGS_PACKAGES_VARIABLE}};${LIBREPOMGR_PACKAGE}" PARENT_SCOPE)

    if (ARGS_ONLY_HEADERS)
        return ()
    endif ()

    # add required Qt and KF modules
    set(IMPORTED_QT_MODULES
        ${IMPORTED_QT_MODULES}
        ${LIBREPOMGR_PUBLIC_QT_MODULES}
        ${LIBREPOMGR_PRIVATE_QT_MODULES}
        PARENT_SCOPE
    )
    set(IMPORTED_KF_MODULES
        ${IMPORTED_KF_MODULES}
        ${LIBREPOMGR_PUBLIC_KF_MODULES}
        ${LIBREPOMGR_PRIVATE_KF_MODULES}
        PARENT_SCOPE
    )

    # add required translations to APP_SPECIFIC_QT_TRANSLATION_FILES_ARRAY
    if(LIBREPOMGR_HAS_QT_TRANSLATION_FILES)
        set(APP_SPECIFIC_QT_TRANSLATION_FILES "${APP_SPECIFIC_QT_TRANSLATION_FILES};librepomgr" PARENT_SCOPE)
    endif()

    # add Qt resources if it is a static library
    if (NOT LIBREPOMGR_LIB_IS_SHARED)
        set(STATIC_LIBRARIES_QT_RESOURCES "${STATIC_LIBRARIES_QT_RESOURCES};${LIBREPOMGR_QT_RESOURCES}" PARENT_SCOPE)
    endif()
endfunction()
